package top.jerryyan.RN.A.VersionUpgrade;

import android.app.DownloadManager;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.net.Uri;

import java.io.File;

public class DownLoadBroadcastReceiver extends BroadcastReceiver {
    @Override
    public void onReceive(Context context, Intent intent) {
        long currentDownloadId = intent.getLongExtra(DownloadManager.EXTRA_DOWNLOAD_ID, -1);
        SharedPreferences sPreferences = context.getSharedPreferences("jerry_rn_a_version_upgrade", 0);
        long refernece = sPreferences.getLong("downloadId", 0);
        if (currentDownloadId == refernece) {
            DownloadManager downloadManager = (DownloadManager) context.getSystemService(Context.DOWNLOAD_SERVICE);
            Intent install = new Intent(Intent.ACTION_VIEW);
            DownloadManager.Query queryById = new DownloadManager.Query();
            queryById.setFilterById(currentDownloadId);
            Cursor downloadCursor = downloadManager.query(queryById);
            String filePath = null;
            if(downloadCursor.moveToFirst()){
                if(downloadCursor.getInt(downloadCursor.getColumnIndex(DownloadManager.COLUMN_STATUS)) == DownloadManager.STATUS_SUCCESSFUL){
                    int fileNameIdx = downloadCursor.getColumnIndex(DownloadManager.COLUMN_LOCAL_FILENAME);
                    filePath = downloadCursor.getString(fileNameIdx);
                }else{
                    downloadManager.remove(currentDownloadId);
                    downloadCursor.close();
                    return;
                }
                downloadCursor.close();
            }
            if(filePath == null) return;
            File file = new File(filePath);
            install.setDataAndType(Uri.fromFile(file), "application/vnd.android.package-archive");
            install.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
            context.getApplicationContext().startActivity(install);
        }
    }
}
